searchData={"items":[{"type":"module","title":"Kevo","doc":"Top-level interface and supervisor for Kevo's API and websocket connections.","ref":"Kevo.html"},{"type":"function","title":"Kevo.child_spec/1","doc":"Returns a specification to start this module under a supervisor.\n\nSee `Supervisor`.","ref":"Kevo.html#child_spec/1"},{"type":"function","title":"Kevo.get_events/4","doc":"Gets the provided lock's event history. Follows the frontend's paging behavior.","ref":"Kevo.html#get_events/4"},{"type":"function","title":"Kevo.get_lock/2","doc":"Retrieves the given lock's state.","ref":"Kevo.html#get_lock/2"},{"type":"function","title":"Kevo.get_locks/1","doc":"Retrieves all locks visible to the logged in user.","ref":"Kevo.html#get_locks/1"},{"type":"function","title":"Kevo.lock/2","doc":"Locks the given lock.","ref":"Kevo.html#lock/2"},{"type":"function","title":"Kevo.start_link/1","doc":"Starts an instance of kevo_ex.","ref":"Kevo.html#start_link/1"},{"type":"function","title":"Configuration - Kevo.start_link/1","doc":"* `:name` - Alias of the top-level supervisor. Can be provided if you intend to run multiple instances of `kevo_ex` in your app. Defaults to `Kevo`.\n\n* `:username` - Your Kevo username (required).\n\n* `:password` - Your Kevo password (required).\n\n* `:websocket_callback` - Websocket callback module. Defaults to `nil`.","ref":"Kevo.html#start_link/1-configuration"},{"type":"function","title":"Kevo.unlock/2","doc":"Unlocks the given lock.","ref":"Kevo.html#unlock/2"},{"type":"behaviour","title":"Kevo.Handler","doc":"Handler behaviour for events received from Kevo's websocket.","ref":"Kevo.Handler.html"},{"type":"callback","title":"Kevo.Handler.handle_event/1","doc":"","ref":"Kevo.Handler.html#c:handle_event/1"},{"type":"exception","title":"Kevo.ApiError","doc":"Represents a failed response from Kevo's HTTP/2 API.","ref":"Kevo.ApiError.html"},{"type":"function","title":"Kevo.ApiError.from_body/3","doc":"","ref":"Kevo.ApiError.html#from_body/3"},{"type":"function","title":"Kevo.ApiError.from_headers/4","doc":"","ref":"Kevo.ApiError.html#from_headers/4"},{"type":"function","title":"Kevo.ApiError.from_network/3","doc":"","ref":"Kevo.ApiError.html#from_network/3"},{"type":"function","title":"Kevo.ApiError.from_status/4","doc":"","ref":"Kevo.ApiError.html#from_status/4"},{"type":"function","title":"Kevo.ApiError.message/1","doc":"","ref":"Kevo.ApiError.html#message/1"},{"type":"type","title":"Kevo.ApiError.t/0","doc":"","ref":"Kevo.ApiError.html#t:t/0"},{"type":"extras","title":"kevo_ex","doc":"# kevo_ex\nAn Elixir client library for Kevo's reverse engineered web API.\n\nKevo locks were launched by Kiwkset in 2016 and discontinued in 2022. While they're unlikely to receive support for [Seam](https://www.seam.co/), the existing web API should (hopefully) remain (relatively) stable.","ref":"readme.html"},{"type":"extras","title":"Installation - kevo_ex","doc":"Add `:kevo_ex` to your list of dependencies in `mix.exs`:\n\n \n```elixir\ndef deps do\n  [\n    {:kevo_ex, \"~> 0.2.0\"}\n  ]\nend\n```\n \n\nDocumentation is available on [HexDocs](https://hexdocs.pm/kevo_ex/readme.html) and may also be generated with [ExDoc](https://github.com/elixir-lang/ex_doc).","ref":"readme.html#installation"},{"type":"extras","title":"Usage - kevo_ex","doc":"Add `Kevo` to your app's supervision tree:\n```elixir\nkevo_opts = [\n  name: Kevo,\n  username: \"username\",\n  password: \"password\",\n  websocket_callback: YourHandlerModule # optional\n]\n\nchildren = [\n  {Kevo, kevo_otps}\n]\n```\n\nOr start the client dynamically:\n```elixir\nKevo.start_link([name: Kevo, username: \"username\", password: \"password\"])\n```\n\n##","ref":"readme.html#usage"},{"type":"extras","title":"Configuration - kevo_ex","doc":"* `:name` - Alias of the top-level supervisor. Can be provided if you intend to run multiple instances of kevo_ex. Defaults to `Kevo`.\n\n* `:username` - Your Kevo username (required).\n\n* `:password` - Your Kevo password (required).\n\n* `:websocket_callback` - Websocket callback module. Defaults to `nil`.\n\n##","ref":"readme.html#configuration"},{"type":"extras","title":"API calls - kevo_ex","doc":"* `Kevo.get_locks/0` - Retrieves all locks visible to the logged in user.\n\n* `Kevo.get_lock/1` - Retrieves the given lock's state.\n\n* `Kevo.lock/1` - Locks the given lock.\n\n* `Kevo.unlock/1` - Unlocks the given lock.\n\n* `Kevo.get_events/3` - Gets the provided lock's event history. Follows the frontend's paging behavior.\n\n* `name` can be provided as an additional argument if you aren't using the default.\n\n##","ref":"readme.html#api-calls"},{"type":"extras","title":"Websocket events - kevo_ex","doc":"To receive websocket events, provide a `Kevo.Handler` compliant module using the `websocket_callback` option. When a message is recevied, `handle_event/1` will be invoked, passing a map of the received JSON. See the page on [example responses](./pages/example_responses.md).\n\n##","ref":"readme.html#websocket-events"},{"type":"extras","title":"Usage notes - kevo_ex","doc":"- API calls are made to be as concurrently as possible.\n- Kevo's websocket accepts no messages and is receive only.\n- The websocket will only be opened if `websocket_callback` is provided.\n- This library is unopinionated about how you queue or broker events.","ref":"readme.html#usage-notes"},{"type":"extras","title":"Acknowledgments - kevo_ex","doc":"Special thanks to the following:\n- [dcmeglio](https://github.com/dcmeglio), author of [aiokevoplus](https://github.com/dcmeglio/pykevoplus) (used as reference)\n- [Bahnburner](https://github.com/Bahnburner), author of [pykevoplus3](https://github.com/Bahnburner/pykevoplus)\n- [cseelye](https://github.com/cseelye), author of [pykevoplus](https://github.com/cseelye/pykevoplus)\n- [davidlang42](https://github.com/davidlang42)\n- [b3nji](https://github.com/b3nj1)","ref":"readme.html#acknowledgments"},{"type":"extras","title":"example responses","doc":"# example responses\nThe API responses are rather expansive, so example responses are documented here.\n\nSince this API's reverse engineered these structures may be subject to change over time.\n\n#","ref":"example_responses.html"},{"type":"extras","title":"Basic test script - example responses","doc":"You can use this script evaluate responses for yourself.\n```elixir\ndefmodule TestCallback do\n  def handle_event(json) do\n    IO.inspect(json, label: \"Got a websocket message •ᴗ•\")\n  end\nend\n\nLogger.configure(level: :debug)\n\nKevo.start_link([\n  name: Kevo,\n  username: System.get_env(\"KEVO_USER\"),\n  password: System.get_env(\"KEVO_PASSWORD\"),\n  ws_callback_module: TestCallback\n])\n```\n\n### `Kevo.get_lock/1`\n```elixir\n%{\n  \"batteryChargeStatus\" => 0,\n  \"batteryLevel\" => 40,\n  \"batteryLevelCritical\" => 0.3,\n  \"batteryLevelLow\" => 0.4,\n  \"batteryLevelOk\" => 0.5,\n  \"boltState\" => \"Locked\",\n  \"boltStateTime\" => \"2023-12-01T19:31:31.557\",\n  \"brand\" => \"Kwikset\",\n  \"description\" => \"No Description Set\",\n  \"deviceStates\" => [],\n  \"features\" => [\n    %{\n      \"available\" => true,\n      \"feature\" => 16,\n      \"reason\" => 0,\n      \"requiredVersion\" => \"0.2.3\"\n    },\n    %{\n      \"available\" => true,\n      \"feature\" => 32,\n      \"reason\" => 0,\n      \"requiredVersion\" => \"0.2.3\"\n    },\n    %{\n      \"available\" => true,\n      \"feature\" => 64,\n      \"reason\" => 0,\n      \"requiredVersion\" => \"0.2.3\"\n    },\n    # ...\n    %{\n      \"available\" => true,\n      \"feature\" => 8192,\n      \"reason\" => 0,\n      \"requiredVersion\" => \"1.2.14\"\n    },\n    %{\n      \"available\" => true,\n      \"feature\" => 1,\n      \"reason\" => 0,\n      \"requiredVersion\" => \"0.2.3\"\n    },\n    %{\n      \"available\" => true,\n      \"feature\" => 2,\n      \"reason\" => 0,\n      \"requiredVersion\" => \"0.2.3\"\n    },\n    # ...\n  ],\n  \"firmwareVersion\" => \"1.9.49\",\n  \"hardwareType\" => 4,\n  \"id\" => \"95fb0051-da97-468e-8170-c5033156401c\",\n  \"lastHistorySequenceNumber\" => 112362,\n  \"mainsPowerStatus\" => 0,\n  \"name\" => \"Front Door\",\n  \"permissions\" => [\n    %{\n      \"certificate\" => \"\",\n      \"created\" => \"2019-12-03T23:08:43.893\",\n      \"deviceDbuToken\" => \"\",\n      \"deviceVerificationToken\" => \"\",\n      \"grantee\" => %{\n        \"id\" => \"89426e98-f370-42a4-a89d-3967b5b2aed4\",\n        \"profile\" => %{\"firstName\" => \"Gordon\", \"lastName\" => \"Freeman\"},\n        \"username\" => \"gfreeman@bmesa.org\"\n      },\n      \"grantor\" => %{\n        \"id\" => \"89426e98-f370-42a4-a89d-3967b5b2aed4\",\n        \"profile\" => %{\"firstName\" => \"Gordon\", \"lastName\" => \"Freeman\"},\n        \"username\" => \"gfreeman@bmesa.org\"\n      },\n      \"id\" => \"7e0ca53b-34b5-454f-8639-e45e394dbf36\",\n      \"message\" => \"\",\n      \"name\" => \"Front Door\",\n      \"status\" => \"Accepted\",\n      \"type\" => \"Owner\"\n    },\n    %{\n      \"certificate\" => \"\",\n      \"created\" => \"2019-12-03T23:23:56.673\",\n      \"deviceDbuToken\" => \"\",\n      \"deviceVerificationToken\" => \"\",\n      \"grantee\" => %{\n        \"id\" => \"d05f6193-8ab8-456f-bf1d-3f73acb0f615\",\n        \"profile\" => %{\"firstName\" => \"John\", \"lastName\" => \"Doe\"},\n        \"username\" => \"jdoe@anonymous.com\"\n      },\n      \"grantor\" => %{\n        \"id\" => \"89426e98-f370-42a4-a89d-3967b5b2aed4\",\n        \"profile\" => %{\"firstName\" => \"Gordon\", \"lastName\" => \"Freeman\"},\n        \"username\" => \"gfreeman@bmesa.org\"\n      },\n      \"id\" => \"984d6a2b-788d-460b-9545-0d0fca6ab418\",\n      \"message\" => \"\",\n      \"name\" => \"419\", # not always a number, could be any string\n      \"status\" => \"Accepted\",\n      \"type\" => \"Admin\"\n    },\n    %{\n      \"certificate\" => \"\",\n      \"created\" => \"2023-09-14T16:52:34.427\",\n      \"deviceDbuToken\" => \"\",\n      \"deviceVerificationToken\" => \"\",\n      \"grantee\" => %{\n        \"id\" => \"d0776b9d-33c0-497b-841a-01f1c0862979\",\n        \"profile\" => %{\"firstName\" => \"Bobby\", \"lastName\" => \"Tables\"},\n        \"username\" => \"btables@drops.com\"\n      },\n      \"grantor\" => %{\n        \"id\" => \"89426e98-f370-42a4-a89d-3967b5b2aed4\",\n        \"profile\" => %{\"firstName\" => \"Gordon\", \"lastName\" => \"Freeman\"},\n        \"username\" => \"gfreeman@bmesa.org\"\n      },\n      \"id\" => \"133aa8cc-4035-48f4-b09e-1875dc02bfd2\",\n      \"message\" => \"\",\n      \"name\" => \"Front Door\",\n      \"status\" => \"Accepted\",\n      \"type\" => \"Guest\"\n    },\n    # ...\n    %{\n      \"certificate\" => \"redacted\",\n      \"created\" => \"2023-10-02T16:53:11.283\",\n      \"deviceDbuToken\" => \"redacted\",\n      \"deviceVerificationToken\" => \"redacted\",\n      \"grantee\" => %{\"id\" => \"64d4dd5d-4600-416f-8518-6a9368a2c1b7\"},\n      \"grantor\" => %{\n        \"id\" => \"89426e98-f370-42a4-a89d-3967b5b2aed4\",\n        \"profile\" => %{\"firstName\" => \"Gordon\", \"lastName\" => \"Freeman\"},\n        \"username\" => \"gfreeman@bmesa.org\"\n      },\n      \"id\" => \"b8b6ccf6-3593-4ec9-9219-06e881073f8c\",\n      \"message\" => \"\",\n      \"status\" => \"Accepted\",\n      \"type\" => \"Device\",\n      \"validFrom\" => \"2023-10-02T16:53:11\",\n      \"validTo\" => \"2033-10-02T16:53:11\"\n    }\n  ],\n  \"productDescriptor\" => \"DBU2KWK0001\",\n  \"sequenceNumber\" => 112368,\n  \"stats\" => %{\n    \"activePermissions\" => 24,\n    \"availableKeyCount\" => 0,\n    \"disabledPermissions\" => 0,\n    \"lastAccessed\" => \"2023-12-01T19:38:56.498865Z\",\n    \"maxKeyCount\" => 25,\n    \"openPermissions\" => 25,\n    \"pendingPermissions\" => 1,\n    \"rejectedPermissions\" => 0,\n    \"remainingKeyCount\" => 0,\n    \"revokedPermissions\" => 0,\n    \"totalKeyCount\" => 25\n  },\n  \"status\" => \"Paired\",\n  \"timeOffset\" => -5.0,\n  \"upgradeStatus\" => \"UpgradeNotAvailable\"\n}\n```\n\n### `Kevo.get_locks/0`\nA list of locks following the above schema.\n\n### `Kevo.get_events/3`\nEvents appear to be in descending order, recent to oldest.\n\n```elixir\n%{\n  \"currentPage\" => 1,\n  \"events\" => [\n    %{\n      \"event\" => \"AutoLock\",\n      \"id\" => \"1124162023fa1e598d54eaf9eecd6e1387807bac05\",\n      \"target\" => \"Front Door\",\n      \"timeStamp\" => \"2023-12-01T19:40:59Z\",\n      \"timeStampLocal\" => \"2023-12-01T14:40:59\"\n    },\n    %{\n      \"event\" => \"Unlock\",\n      \"id\" => \"1123742023fa1e598d54eaf9eecd6e1387807bac05\",\n      \"performer\" => \"Walter Clements\",\n      \"target\" => \"Front Door\",\n      \"timeStamp\" => \"2023-12-01T19:40:18Z\",\n      \"timeStampLocal\" => \"2023-12-01T14:40:18\"\n    },\n    # ...\n    %{\n      \"event\" => \"AutoLock\",\n      \"id\" => \"1123592023fa1e598d54eaf9eecd6e1387807bac05\",\n      \"target\" => \"Front Door\",\n      \"timeStamp\" => \"2023-12-01T19:20:23Z\",\n      \"timeStampLocal\" => \"2023-12-01T14:20:23\"\n    },\n    %{\n      \"event\" => \"ManualUnlock\",\n      \"id\" => \"1123562023fa1e598d54eaf9eecd6e1387807bac05\",\n      \"target\" => \"Front Door\",\n      \"timeStamp\" => \"2023-12-01T19:19:51Z\",\n      \"timeStampLocal\" => \"2023-12-01T14:19:51\"\n    },\n    # ...\n  ],\n  \"fetchCount\" => 10,\n  \"totalCount\" => 1000,\n  \"totalPages\" => 100\n}\n```\n\n#","ref":"example_responses.html#basic-test-script"},{"type":"extras","title":"Websocket events: - example responses","doc":"Here's a few events in descending order, first toggling the lock via bluetooth, then manually.\n\n*Note: This isn't an exhaustive list.*\n\n```elixir\n%{\n  \"hmac\" => \"3aZRKZ8z6zqX7F0jic9fQFm1WACtySvYcNuoIHTneeM=\",\n  \"messageData\" => %{\n    \"Nonce\" => nil,\n    \"batteryChargeStatus\" => 0,\n    \"batteryLevel\" => 100,\n    \"boltState\" => 2,\n    \"boltStateTime\" => \"2023-12-01T20:28:59.6583209\",\n    \"command\" => nil,\n    \"communicationStatus\" => 1,\n    \"communicationStatusTime\" => \"2023-12-01T20:28:43.963\",\n    \"deviceStates\" => [],\n    \"historySequenceNumber\" => 35549,\n    \"lockId\" => \"551b8e95-487f-4d8d-9438-70c3b390e4b1\",\n    \"mainsPowerStatus\" => 0,\n    \"sequenceNumber\" => 35552,\n    \"timestamp\" => \"2023-12-01T20:28:59.7663247\"\n  },\n  \"messageLength\" => 390,\n  \"messageType\" => \"LockStatus\"\n}\n# ...\n%{\n  \"hmac\" => \"Z4FX64yCYOPZ5sksgCtTNPtamEzTBkH4X8mgJM/keVc=\",\n  \"messageData\" => %{\n    \"Nonce\" => nil,\n    \"batteryChargeStatus\" => 0,\n    \"batteryLevel\" => 100,\n    \"boltState\" => 2,\n    \"boltStateTime\" => \"2023-12-01T20:28:59.657\",\n    \"command\" => nil,\n    \"communicationStatus\" => 1,\n    \"communicationStatusTime\" => \"2023-12-01T20:28:43.963\",\n    \"deviceStates\" => [],\n    \"historySequenceNumber\" => 35552,\n    \"lockId\" => \"551b8e95-487f-4d8d-9438-70c3b390e4b1\",\n    \"mainsPowerStatus\" => 0,\n    \"sequenceNumber\" => 35552,\n    \"timestamp\" => \"2023-12-01T20:29:01.3667579\"\n  },\n  \"messageLength\" => 386,\n  \"messageType\" => \"LockStatus\"\n}\n# ...\n%{\n  \"hmac\" => \"fenPmaMK5IuiOg+Kj9+YRr8WiT1EvhCfJwsGkxZeqVM=\",\n  \"messageData\" => %{\n    \"Nonce\" => nil,\n    \"batteryChargeStatus\" => 0,\n    \"batteryLevel\" => 100,\n    \"boltState\" => 1,\n    \"boltStateTime\" => \"2023-12-01T20:29:08.171172\",\n    \"command\" => nil,\n    \"communicationStatus\" => 1,\n    \"communicationStatusTime\" => \"2023-12-01T20:28:43.963\",\n    \"deviceStates\" => [],\n    \"historySequenceNumber\" => 35552,\n    \"lockId\" => \"551b8e95-487f-4d8d-9438-70c3b390e4b1\",\n    \"mainsPowerStatus\" => 0,\n    \"sequenceNumber\" => 35559,\n    \"timestamp\" => \"2023-12-01T20:29:08.3527448\"\n  },\n  \"messageLength\" => 389,\n  \"messageType\" => \"LockStatus\"\n}\n# ...\n%{\n  \"hmac\" => \"OvFiALsSLlL+5lV3Q6h/TMPWu1CvxkK5j2Ct07YplQg=\",\n  \"messageData\" => %{\n    \"Nonce\" => nil,\n    \"batteryChargeStatus\" => 0,\n    \"batteryLevel\" => 100,\n    \"boltState\" => 1,\n    \"boltStateTime\" => \"2023-12-01T20:29:08.17\",\n    \"command\" => nil,\n    \"communicationStatus\" => 1,\n    \"communicationStatusTime\" => \"2023-12-01T20:28:43.963\",\n    \"deviceStates\" => [],\n    \"historySequenceNumber\" => 35559,\n    \"lockId\" => \"551b8e95-487f-4d8d-9438-70c3b390e4b1\",\n    \"mainsPowerStatus\" => 0,\n    \"sequenceNumber\" => 35559,\n    \"timestamp\" => \"2023-12-01T20:29:09.4513288\"\n  },\n  \"messageLength\" => 385,\n  \"messageType\" => \"LockStatus\"\n}\n# ...\n%{\n  \"hmac\" => \"2sdJ1t/zfwF+ENkQhIgg6MVQ9F34NK+lq9PBXk0t3Us=\",\n  \"messageData\" => %{\n    \"Nonce\" => nil,\n    \"batteryChargeStatus\" => 0,\n    \"batteryLevel\" => 100,\n    \"boltState\" => 1,\n    \"boltStateTime\" => \"2023-12-01T20:29:08.17\",\n    \"command\" => nil,\n    \"communicationStatus\" => 1,\n    \"communicationStatusTime\" => \"2023-12-01T20:28:43.963\",\n    \"deviceStates\" => [],\n    \"historySequenceNumber\" => 35565,\n    \"lockId\" => \"551b8e95-487f-4d8d-9438-70c3b390e4b1\",\n    \"mainsPowerStatus\" => 0,\n    \"sequenceNumber\" => 35559,\n    \"timestamp\" => \"2023-12-01T20:29:25.513874\"\n  },\n  \"messageLength\" => 384,\n  \"messageType\" => \"LockStatus\"\n}\n```","ref":"example_responses.html#websocket-events"}],"content_type":"text/markdown"}